#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:
#
# Author:      Jim2
#
# Created:     16/12/2017
# Copyright:   (c) Jim2 2017
# Licence:     <your licence>
#-------------------------------------------------------------------------------
import os, wx, serial, threading,upTools, images
from noname import frmTwit, frmEsptool, frmEdit, dlgCopyFile
from config import Config
from time import sleep
from xml.parsers import expat
import sys, os

VERSION = '1.8'
## use relative paths to files
EDITOR = '/edit/PSPad.exe'
ESPTOOL = '/esptool-master/esptool.py'
CONFIG = 'config.ini'

# +++++++++++++++++++++++++++++ drag and drop ++++++++++++++++++++++++++++++++++
class MyFileDropTarget(wx.FileDropTarget):
    # ----------------------------------------------------------------------
    def __init__(self, object):
        """Constructor"""
        wx.FileDropTarget.__init__(self)
        self.object = object

    # ----------------------------------------------------------------------
    def OnDropFiles(self, x, y, filenames):
        """
        filenames include full path csv
        """
        self.object(filenames)
        return 0


# ++++++++++++++++++++++++++++++++++ MAIN ++++++++++++++++++++++++++++++++++++++
class twit(frmTwit,frmEsptool,frmEdit,dlgCopyFile):
    def __init__(self):
        frmTwit.__init__(self,None)
        self.cfg = Config(CONFIG)
        self.cfg.save_option('system','version',VERSION)

        # keeps track of selected file on file tree [type,fname]
        self.current_file = []
        # Drag and drop
        self.progpath = os.path.dirname(os.path.realpath('upconnect.py')) # needed, not same as cwd        
        file_drop_target = MyFileDropTarget(self.add_file)
        self.treeFile.SetDropTarget(file_drop_target)
        # internals
        self.comisopen = False
        self.outputbuffer =''
        self._reader_alive = False
        self.start_up()
        # history
 #       self.line = ''
        self.history = []
        self.hcount = 0
#        self.lineStart = 3

    def OnDropFiles(self, x, y, filenames):
        print('here')
    # =========================================================================
    # overrides GUI enevts
    # =========================================================================
    def frmClose(self, event):
        if self.comisopen:
            self.com_close()
        self.Destroy()
#        self.popDelete.Destroy()

    def btneConnect( self, event):
        if self.comisopen:
            self.com_close()
            print('disconnecting')
            self.btnConnect.SetBitmapLabel(self.btnConnect.GetBitmapDisabled())
            self.cboPort.Enabled = True
            self.cboBaud.Enabled = True
        else:
            self.com_open()
            print('connecting')
            self.btnConnect.SetBitmapLabel(self.btnConnect.GetBitmapPressed())
            #devicepresent = upTools.check_device(self.serial)
            #self.start_reader()
            self.btnReset.Enable()
            self.txtTerm.SetValue('') # clear terminal
            self.txtTerm.SetFocus()
            self.cboPort.Enabled = False
            self.cboBaud.Enabled = False
            self.m_panel8.Enabled = True
            self.mnuESPProgram.Enable(True)
            #self.mnuESPprogram.Enabled = True
            self.btneReset(None)
            self.btneFilerefresh(None)  # starts reader 
 #           print('present=',devicepresent)
 #           if devicepresent:
 #               self.toolFile.Enabled = True

    # **************************************************************************
    def portsCombo(self):
        self.cboPort.Clear()
        cports = self.get_ports()
        if  len(cports) > 0:
            for p in cports:
                self.cboPort.AppendItems(p)
            oldport = self.cfg.get_option('Terminal','port').upper()
            if oldport is not None: # set to previous value
                self.cboPort.SetValue(oldport)
        else:
            self.cboPort.SetValue('')
            self.cfg.save_option('Terminal', 'port', '') # update ini

    
    def cboePort( self, event ):
        index = self.cboPort.GetSelection()
        value = self.cboPort.GetString(index)
        self.cfg.save_option('Terminal','port',value)

    def cboeBaud( self, event ):
        index = self.cboBaud.GetSelection()
        value = self.cboBaud.GetString(index)
        self.cfg.save_option('Terminal','baud',value)

    def btneReset(self, event):
        self.serial.setDTR(False)
        sleep(.5)
        self.serial.setDTR(True)
        self.txtTerm.SetFocus()

    #
    def chkeDTR( self, event ):
        if self.comisopen:
            if '1' in self.cfg.get_option('Terminal', 'dtr'):
                self.serial.setDTR(False)
                print('DTR is false')
                self.chkDTR.SetValue(False)
                self.cfg.save_option('Terminal', 'dtr', '0')
            else:
                self.serial.setDTR(True)
                print('DTR is true')
                self.cfg.save_option('Terminal', 'dtr', '1')
                self.chkDTR.SetValue(True)

    #
    def chkeRTS( self, event ):
        if self.comisopen:
            if '1' in self.cfg.get_option('Terminal','rts'):
                self.serial.setRTS(False)
                print('RTS is flase')
                self.chkRTS.SetValue(False)
                self.cfg.save_option('Terminal', 'rts', '0')
            else:
                self.serial.setRTS(True)
                print('RTS is true')
                self.chkRTS.SetValue(True)
                self.cfg.save_option('Terminal', 'rts', '1')

    def btneRefresh(self, event):
        self.portsCombo()

    # +++++++++++++++++++++++++++++ TEXT TERMINAL +++++++++++++++++++++++++++++++++++++++
    # helper of key entry    
    def textInfo(self):    
        ip = self.txtTerm.GetInsertionPoint()
        t, col, row = self.txtTerm.PositionToXY(ip)
        startOfLine = self.txtTerm.XYToPosition(0, row)
        currentSelected = self.txtTerm.GetStringSelection()
        currentLine = self.txtTerm.GetLineText(row)
#        print('ip={},t={},col={},row={},startOfLine={},currentSelected={},currentLine={}'.format(ip,t,col,row,startOfLine,currentSelected,currentLine))            
        return [ip,t,col,row,startOfLine,currentSelected, currentLine]
            
    # capture every character but pass on to text enter
    def txteChr(self, event):
        key = event.GetKeyCode()
        self.txtTerm.SetDefaultStyle(wx.TextAttr('WHITE'))

#        print(key)
        if key == 1:
            self.serial.write(b'\x01')
        elif key == 2:
            self.serial.write(b'\x02')
        elif key == 4:
            self.serial.write(b'\x04')
        elif key == 5:
            self.serial.write(b'\x05')
            text_wtite('\152', 'CYAN')
 #       elif key == 314: # left arrow
 #           pass
        elif key == 315: # up arrow
            if self.hcount > 0:
                self.hcount -= 1
                text = self.history[self.hcount]
                # calculate where to put history text
                ti = self.textInfo()
                self.txtTerm.Remove(ti[4]+4,ti[0])
                print('hist=',self.history)
                self.text_wtite(text, 'MAGENTA')
 #       elif key == 316: # right arrow
 #           self.txtTerm.SetInsertionPoint(0)
 #           self.txtTerm.WriteText('fred')
        elif key == 317: # down arrow
            if  self.hcount < len(self.history):
                self.hcount += 1
                text = self.history[self.hcount]
                # calculate where to put history text
                ti = self.textInfo()
                self.txtTerm.Remove(ti[4]+4,ti[0])
                self.text_wtite(text, 'MAGENTA')
        elif key == 9:
            ti = self.textInfo()
            if len(ti[5]) > 0:
                text = ti[5]
            else:
                text = ti[6]
                if '>>>' in ti[6]: ti[6].replace('>>>','')
                if '===' in ti[6]: ti[6].replace('===','')
            self.text_wtite(text+'\n','GREEN')
            self.com_writer(text)
        else:
            event.Skip() # to txtEnter

    # event when text is entered in the main window and CR pressed
    def txteEnter(self, event):
        ti = self.textInfo()
        text = self.txtTerm.GetLineText(ti[3]-1)[4:] # always a prompt
        print('sending[{}]'.format(text))
        self.com_writer(text)
        # update history
        if len(text) > 0:
            self.history.append(text)
            self.hcount = len(self.history)

    # *************************************************************************
    # sends clipboard to terminal
    # *************************************************************************
    def btnePaste(self, event):
        self.stop_reader()
        valid, rv = upTools.clip_transfer(self.serial)
        if valid:
            self.text_wtite(rv,'GREEN')
        else:
            self.text_wtite(rv, 'RED')
        self.start_reader()
        self.txtTerm.SetFocus()

    # =========================================================================
    # ============================= File Tree =================================
    # =========================================================================
    def btneFilerefresh(self, event):
        self.stop_reader()
        rv = upTools.listDir(self.serial) # returns dictionary        
        self.start_reader()
        print('len rv=',len(rv))
        self.treeFile.DeleteChildren(self.root)
        self.nodeStack = [self.root]

        # Define a handler for start element events
        def StartElement(name, dir ):
            id = self.treeFile.AppendItem(self.nodeStack[-1], name)
            self.nodeStack.append(id)
            if dir:
                self.treeFile.SetItemImage(id, self.fldridx, wx.TreeItemIcon_Normal)
                self.treeFile.SetItemData(id, 'dir')
            else:
                self.treeFile.SetItemImage(id, self.fileidx, wx.TreeItemIcon_Normal)
                self.treeFile.SetItemData(id, 'file')

        def EndElement():
            self.nodeStack = self.nodeStack[:-1]

        def subdir(dir):
            dirname = dir.split(';')[0]
            StartElement(dirname,True)
            for file in sorted(rv[dir]):
                type = file.split(';')
                if type[1] != '1':
                    StartElement(type[0],False)
                    EndElement()
                else:
                    subdir(file)
            EndElement()

        # create tree from received directory and file list, or 'no files' if not
        # a uPython device
        if len(rv) > 1:
            subdir('/;1')
            self.treeFile.ExpandAll()
        else:
            StartElement('No Files',0)

    # *************************************************************************
    # D E L E T E  F I L E  OR  F O L D E R
    # *************************************************************************
    def popeDelete(self, event):
        try:
            target = self.treeFile.GetItemText(self.treeFile.GetSelection())
            ftype =  self.treeFile.GetItemData(self.treeFile.GetSelection())
        except:
            target = 'No File Selected'
        print('type {}, file {}'.format(ftype,target))
        dlg = wx.TextEntryDialog(self, '','Delete File', '')
        dlg.SetValue(target)
        if dlg.ShowModal() == wx.ID_OK:
            self.stop_reader()
            upTools.delete_file(self.serial, target,ftype)
            self.btneFilerefresh(None)  # starts reader again

        
    # *************************************************************************
    # A D D  F I L E  O R  F O L D E R
    # Adds file by drag and drop on the tree control
    # *************************************************************************
    def add_file(self,filenames):
        self.stop_reader()
        for file in filenames:
            path, filename = os.path.split(file)
            if os.path.isdir(filename):
                print('addinf directory')
            else:
                print('Drop filename=', path, filename)
#                upTools.sendfile(self.serial, file, filename,self)
                upTools.saveAny(self.serial,file,filename,self)
        self.btneFilerefresh(None)  # starts reader again

    # new folder
    def popeNewfolder( self, event ):
        new_folder = None
        dlg = wx.TextEntryDialog(self, 'Care: Duplicates not checked','New Folder Name', '')
        dlg.SetValue("NewFolder")
        if dlg.ShowModal() == wx.ID_OK:
            new_folder = dlg.GetValue()
        print('new_folder=',new_folder)
        if new_folder is not None:
            self.stop_reader()
            upTools.new_folder(self.serial,new_folder)
            self.btneFilerefresh(None)  # starts reader again
            
    # send file to host
    # on tree context menu
    # 1) gets local file name and contents
    # 2) checks for duplicates, gets pathto pc
    # 3) daves path and file name in ini file for future
    def popeSendto( self, event ):
        def btneCopyFileok(event ):
            # 1) check for existng file with warning
            fname = cpy.picCopyfile.GetPath()
            if os.path.isfile(fname):
                dlg = wx.MessageDialog(self, 'File exists overwrite?','Warning',wx.YES_NO | wx.NO_DEFAULT| wx.ICON_INFORMATION)
                if dlg.ShowModal() == wx.ID_NO:
                    cpy.Destroy()
                    return
            # save
            path, fn = os.path.split(fname) # fname is full path and file
            #print('You entered: {}\n'.format(fn) )  
            self.cfg.save_option('files','pcpath',path)
            self.cfg.save_option('files','lastfile',fn)
                    
            # 2) open file and write
            with open(fname, 'w') as f:
                f.write(contents)
            f.close()    
            cpy.Destroy()
    
        def btneCopyFilecancel(event ):
            cpy.Destroy()
            
        self.stop_reader()
        fname = self.current_file[1]
        path = self.cfg.get_option('files','pcpath')
        valid, contents = upTools.get_file_contents(self.serial,fname)
        if valid:
            #print('file = {}\r\n=== contents ====\r\n{}\r\n=============='.format(fname,contents))
            cpy = dlgCopyFile(self) # create
            cpy.btnCopyFileok.Bind( wx.EVT_BUTTON, btneCopyFileok )
            cpy.btnCopyFilecancel.Bind( wx.EVT_BUTTON, btneCopyFilecancel )
            if path is not None:
                fullpath = path+'\\'+fname
            else:
                fullpath = fname
            print(fullpath)
            cpy.picCopyfile.SetPath(fullpath)
            cpy.Show(True)
        else:
            self.text_wtite("Select a file first", "RED")
        self.start_reader()    

    # *************************************************************************
    # change file name by editing node on tree view
    # *************************************************************************
    def treeBeginedit(self, event):
        self.oldnodename = event.GetLabel()

    def treeEndedit(self, event):
        newname = event.GetLabel()
        if len(newname) > 0:
            print('old={}, new={}'.format(self.oldnodename,newname))
            self.serial.write(b'import os\r\n')
            self.serial.write(str.encode('os.rename("'+self.oldnodename+'","'+newname+'")\r\n'))


    # *************************************************************************
    # SIMPLE EDIT / View
    # *************************************************************************
    def btneFileedit(self, event):
        rv = ''
        target = None
        valid = False

        # send helper        
        def Send(text):
            self.stop_reader()
            valid, rv = upTools.paste_send(self.serial,text)
            if valid:
                self.text_wtite(rv, 'GREEN')
            else:
                self.text_wtite(rv, 'RED')
            self.start_reader()

        # clear sandbox
        def btneSandNew(event):
            edit.txtEdit.SetValue('')

        # send only selected text
        def btneSandPaste(event):
            text = edit.txtEdit.GetStringSelection()
            Send(text)

        # send all of text    
        def btneSandPasteall(event):
            newcontents = edit.txtEdit.GetValue()
            Send(newcontents)

        # saves to local file
        def btneSavelocal(event):
            self.stop_reader()
            fname = edit.txtSandLocal.GetValue()
            newcontents = edit.txtEdit.GetValue()
            lines = []
            #count =0
            for line in newcontents.splitlines():
                #print('{} {}'.format(count,line))
                #count += 1
                lines.append(line)
            #print('sending=',lines)
            upTools.saveText(self.serial,lines,fname,self)
            self.btneFilerefresh(None)  # starts reader again      

        try:
            target = self.treeFile.GetItemText(self.treeFile.GetSelection())
        except:
            pass
            #wx.MessageBox('Select a file First', 'Mini Edit', wx.OK | wx.ICON_INFORMATION)
        edit = frmEdit(self)  # create
        self.Bind(wx.EVT_TOOL, btneSandNew, id = edit.btnSandNew.GetId())
        self.Bind(wx.EVT_TOOL, btneSandPaste, id = edit.btnSandPaste.GetId())
        self.Bind(wx.EVT_TOOL, btneSandPasteall, id = edit.btnSandPasteall.GetId())
        self.Bind(wx.EVT_TOOL, btneSavelocal, id = edit.btnSavelocal.GetId())
        #self.stop_reader()
        if target is not None:
            valid, contents = upTools.get_file_contents(self.serial,target)
            edit.txtSandLocal.SetValue(target)
            #edit.txtSandLocal.SetValue(self.lblDir.GetLabel()+target)
        #self.start_reader()
#        for l in contents.splitlines():
#            print('l=',l)
        edit.txtEdit.SetValue(contents)
        edit.Show(True)

    # *************************************************************************
    # cleates a list of where we are on the directory structure so that the
    # device can change to that directory from anywhere
    # *************************************************************************
    def dir_stack(self,item):
        stack=[]
        while True:
            try:
                p = self.treeFile.GetItemParent(item)
                stack.append(self.treeFile.GetItemText(p))
                item = p
            except:
                return stack

    # *************************************************************************
    # S E L E C  T  F I L E  O R  D I R
    # left mouse click on the tree view,changes directory on the device
    # *************************************************************************
    def treeLeftdown( self, event ):
        pt = event.GetPosition()
        item, _ = self.treeFile.HitTest(pt)
        if item:
            self.treeTarget = self.treeFile.GetItemText(item)  # this is the label of the node
            target = self.treeFile.GetItemText(item)
            ftype =  self.treeFile.GetItemData(item)        
        dd = ''        
        self.current_file = [ftype]+[target]
        #print('stack=',self.current_file,self.dir_stack(item))
        if ftype != 'dir':
            for dir in reversed(self.dir_stack(item)):
                if 'Device Files' in dir: continue # top level
                #print('dir={}, len={}, dd={}'.format(dir,len(dir),dd))
                if (len(dd) > 2) and (dir[0] != '/'): dir = '/'+dir
                dd += dir
        else:
            dd = target
        self.lblDir.SetLabel(dd)
        self.stop_reader()
        upTools.cd(self.serial,dd)
        self.start_reader()
        event.Skip() # important pass to next level

    # ====================================================================
    # text terminal
    def text_wtite(self, text, colour):
        self.txtTerm.SetDefaultStyle(wx.TextAttr(colour))
        self.txtTerm.WriteText(text)

    # *************************************************************************
    # E S P  P R O G R A M M I N G
    # *************************************************************************
    def mnueESPprogram( self, event ):
        def cboeESPfunction(event):
            print('here=',espDlg.cboESPfunction.GetValue())
            if espDlg.cboESPfunction.GetValue() == 'erase_flash':
                espDlg.txtESPoptional.SetValue('')
            if espDlg.cboESPfunction.GetValue() == 'write_flash':
                espDlg.txtESPoptional.SetValue('--flash_size=detect, 0')
            
        def btneESPcancel(event):
            #print('cancel')
            espDlg.Destroy()

        def btneESPok(event):
            func = espDlg.cboESPfunction.GetValue()
            opt = espDlg.txtESPoptional.GetValue()
            img = espDlg.fpiESP.GetPath()
            args = ['python',self.progpath+'/'+(ESPTOOL),'-p'+self.serial.portstr]
            args.append(func)
            if len(opt) > 0:
                args.append(opt.split(','))
            if len(img) > 0:                
                args.append(img)
            print('args=',args)
            self.stop_reader()
            self.serial.close()
            import subprocess
            subprocess.call(args)
            self.com_open()
            self.start_reader()
            espDlg.Destroy()

        espDlg = frmEsptool(self)                
        espDlg.btnESPcancel.Bind(wx.EVT_BUTTON, btneESPcancel)
        espDlg.btnESPok.Bind(wx.EVT_BUTTON, btneESPok)
        espDlg.cboESPfunction.Bind(wx.EVT_COMBOBOX, cboeESPfunction)
        espDlg.Show(True)
        


    # *************************************************************************
    # START UP
    # *************************************************************************
    def start_up(self):
        # buttons
        self.btnReset.Disable()
        self.m_panel8.Disable()
        self.mnuESPProgram.Enable(False)
        
        # populate combo box
        self.portsCombo()
        # baud rate
        oldbaud = self.cfg.get_option('Terminal', 'baud')
        if oldbaud is not None:
            self.cboBaud.SetValue(oldbaud)
        # dtr
        dtr = self.cfg.get_option('Terminal', 'dtr')
        if dtr is not None:
            if '1' in dtr:
                self.chkDTR.Value = True

        # Tree View
        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        self.fldridx     = il.Add(wx.ArtProvider.GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        self.fldropenidx = il.Add(wx.ArtProvider.GetBitmap(wx.ART_FOLDER_OPEN, wx.ART_OTHER, isz))
        self.fileidx     = il.Add(wx.ArtProvider.GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))

        self.treeFile.SetImageList(il)
        self.il = il

        self.root = self.treeFile.AddRoot("Device Files")
        self.treeFile.SetItemData(self.root, None)
        self.treeFile.SetItemImage(self.root, self.fldridx, wx.TreeItemIcon_Normal)
        self.treeFile.SetItemImage(self.root, self.fldropenidx, wx.TreeItemIcon_Expanded)

        

    def get_ports(self):
        AvailablePorts=[]
        try:
            from serial.tools.list_ports import comports
        except ImportError:
            comports = None
        else:
            for port, desc, hwid in sorted(comports()):
                #AvailablePorts.append([port,desc])
                AvailablePorts.append([port])
        return AvailablePorts

    def com_open(self):
        port = self.cfg.get_option('Terminal', 'port')
        baud = self.cfg.get_option('Terminal', 'baud')
        try:
            print('port, baud',port,baud)
            self.serial = serial.serial_for_url(port, baud, rtscts=False, timeout=1)
            self.comisopen = True
        except AttributeError:
            # happens when the installed pyserial is older than 2.5. use the
            # Serial class directly then.
            self.serial = serial.Serial(port, baud, rtscts=False, timeout=1)
            self.comisopen = True

    def com_close(self):
        self.stop_reader()
        self.serial.close()
        self.comisopen = False
        self.btnReset.Disable()

    def start_reader(self):
        self._reader_alive = True
        print('starting reader')
        self.receiver_thread = threading.Thread(target=self.reader)
        self.receiver_thread.start()

    def stop_reader(self):
        if self._reader_alive:
            print('stopping reader')
            self._reader_alive = False
            self.receiver_thread.join() # stop thread

    # reader thread
    def reader(self):
        lastCR =False
        while self._reader_alive:
            raw = self.serial.read(1) # raw byte data as byte aray
            if len(raw) > 0:
                c = raw[0]
                if (c > 31) and (c < 127):
                    self.txtTerm.SetDefaultStyle(wx.TextAttr("YELLOW"))
                    self.txtTerm.AppendText(chr(c))
                    lastCR = False
                else:
                    if (c==10) or (c==13):
                        if not lastCR:
                            self.txtTerm.AppendText('\n')
                            lastCR = True

    def com_writer(self,line):
        self.txtTerm.SetDefaultStyle(wx.TextAttr("WHITE"))
#        line = line.replace('>>>','').lstrip() + '\r\n'
#        line = line.replace('===','').lstrip() + '\r\n'
        if ('>>>' in line[:4]) or ('===' in line[:4]):
            line = line[4:].lstrip() + '\r\n'
        else:
            line = line.lstrip() + '\r\n'
        print('after=',line)
        self.serial.write(str.encode(line))

def main():
    app = wx.App()
    frame = twit()
    frame.Show()
    app.SetTopWindow(frame)
    app.MainLoop()

if __name__ == '__main__':
    main()
